Subject: Re: Problem with rcs...
From: [email-masked] (Erwin Achermann)

10 Mar 1998 09:15:43 -0800
Message-ID: <[email-masked]>
References: <[email-masked]>
Reply-To: [email-masked]
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
To: Ian Lowrey <[email-masked]>
Cc: [email-masked], [email-masked], [email-masked]

I have exactly the same problem, and since my post seemed not to to make
it to the list (It's now 3 days since i posted it) I cc it to Sergey and
Geoffrey, in to hope our help cry will reach people who are concerned 
eventually.
At this opportunity i would like to thank to all of you for your effort
into this whole project.

Erwin

---- Sat 7th, I wrote (but it never made it to the list..)

> Howdy all,
> 
> I have problems using rcs in the presence of a ./RCS directory!
> 
> It seems as if rcs -i fails on some file-handling operations, and
> unfortunatly doesn't realize that particular failure, although (peeking
> into rcsfnms.c) it does some effort to check against them. 
> I'm using Sergeys latest patch, which did fix some file handling
> problems, but there is still a subtle bug lurking arround.
> 
> Maybe the Cygwin32 settings have an impact on this whole issue. 
> mine are "export CYGWIN32=title binmode".
> 
> Can anybody reproduce that odd behavior? If no, what could be the reason
> I see this strange bug? If yes, let's try to squeeze that bug out.
> 
> 
> Here is how the bug manifests:
> 
> note there is  an empty  ./RCS directory
> 
>  /tmp/rcsdbg 86>mkdir RCS
>  /tmp/rcsdbg 87>rcs -i one.txt
>  RCS file: RCS/one.txt,v
>  enter description, terminated with single '.' or end of file:
>  NOTE: This is NOT the log message!
>  >> .
>  done
>  /tmp/rcsdbg 88>ll ; ll RCS
>  total 1
>  -r--r--r--   1 544      everyone        0 Mar  7 10:48 ,one.txt,
>  drwxr-xr-x   4 544      everyone        0 Mar  7 10:48 RCS
>  -rw-r--r--   1 544      everyone       10 Mar  7 10:42 one.txt
>  total 1
>  -r--r--r--   1 544      everyone       64 Mar  7 10:48 one.tx_
>  -r--r--r--   1 544      everyone        0 Mar  7 10:48 one.txt,v
> 
> rcs fails to write usefuld data into RCS/one.txt,v and leaves two
> lock-files ",one.txt," and "RCS/one.tx_" which prohibit any further
> processing trough rcs, ci or co.
> 
> 
> BUT in contrast to that 
> note no ./RCS directory is around:
> 
>  /tmp/rcsdbg 80>ll
>  total 18
>  -rw-r--r--   1 544      everyone       10 Mar  7 10:42 one.txt
>  /tmp/rcsdbg 81>rcs -i one.txt
>  RCS file: one.txt,v
>  enter description, terminated with single '.' or end of file:
>  NOTE: This is NOT the log message!
>  >> .
>  done
>  /tmp/rcsdbg 82>ll
>  total 19
>  -rw-r--r--   1 544      everyone       10 Mar  7 10:42 one.txt
>  -r--r--r--   1 544      everyone       64 Mar  7 10:45 one.txt,v
>  /tmp/rcsdbg 83>
> 
> Everything is fine here, rcs is now ready to use the repository
> one.txt,v.
> 
> 
> Here is the relevant part of the man page of rcs
> 
> -i   Create  and   initialize a new RCS   file,   but do not
>      deposit any revision.  If   the  RCS file has no   path
>      prefix, try to  place  it first  into the  subdirectory
>      ./RCS, and then into the current directory.  If the RCS
>      file already exists, print an error message.

Cheers 
Erwin

Ian Lowrey wrote:
> 
> Hi,
> 
> I'm having a problem getting RCS to work under Cygwin b19 on NT4/SP3. I
> have built the source with the patches given below, and the problem is
> that checking in a file with an "RCS/" directory present fails
> completely (although the ci command reports "done"!). If there is no
> "RCS/" directory present, or the RCS file is given explicitly all is ok.
> It appears that the lock file and RCS file are getting mixed up somehow?
> Advice and guidance from anyone who better understands rcs would be much
> appreciated...
> 
> (CYGWIN32="tty", all mounts text!=binary)
> 
> Changes from original distribution:
> -----------------------------------
> 
> diff orig/rcs-5.7/src/conf.sh /usr/local/src/rcs-5.7/src/conf.sh
> 550c550
> < #     define FOPEN_R_WORK (Expand==BINARY_EXPAND ? "r" : "rb")
> ---
> > #     define FOPEN_R_WORK (Expand==BINARY_EXPAND ? "rb" : "r")
> 552,553c552,553
> < #     define FOPEN_W_WORK (Expand==BINARY_EXPAND ? "w" : "wb")
> < #     define FOPEN_WPLUS_WORK (Expand==BINARY_EXPAND ? "w+" : "w+b")
> ---
> > #     define FOPEN_W_WORK (Expand==BINARY_EXPAND ? "wb" : "w")
> > #     define FOPEN_WPLUS_WORK (Expand==BINARY_EXPAND ? "w+b" : "w+")
> 1039c1039
> <                               has_mmap=1
> ---
> >                               has_mmap=0
> 
> With RCS directory present: (Oops!)
> -----------------------------------
> 
> visage:/home/ian/r% rm -f * RCS/*
> rm: RCS: is a directory
> visage:/home/ian/r% cat > x.c
> l1
> l2
> l3
> ^D
> 
> visage:/home/ian/r% ci x.c
> RCS/x.c,v  <--  x.c
> enter description, terminated with single '.' or end of file:
> NOTE: This is NOT the log message!
> >> .
> initial revision: 1.1
> done
> 
> visage:/home/ian/r% ls -l . RCS
> .:
> total 0
> -r--r--r--   1 544      everyone        0 Mar  8 20:10 ,x.c,
> drwxr-xr-x   4 544      everyone        0 Mar  8 20:10 RCS
> 
> RCS:
> total 1
> -r--r--r--   1 544      everyone      194 Mar  8 20:10 x._
> -r--r--r--   1 544      everyone        0 Mar  8 20:10 x.c,v
> 
> visage:/home/ian/r% co x.c
> co: RCS/x.c,v:1: unexpected end of file
> co aborted
> 
> With explicit RCS file: (ok)
> ----------------------------
> 
> visage:/home/ian/r% rm -f * RCS/*
> rm: RCS: is a directory
> visage:/home/ian/r% cat > x.c
> l1
> l2
> l3
> ^D
> visage:/home/ian/r% ci x.c RCS/x.c,v
> RCS/x.c,v  <--  x.c
> enter description, terminated with single '.' or end of file:
> NOTE: This is NOT the log message!
> >> .
> initial revision: 1.1
> done
> visage:/home/ian/r% ls -l . RCS
> .:
> total 0
> drwxr-xr-x   3 544      everyone        0 Mar  8 20:10 RCS
> 
> RCS:
> total 1
> -r--r--r--   1 544      everyone      194 Mar  8 20:10 x.c,v
> visage:/home/ian/r% co x.c
> RCS/x.c,v  -->  x.c
> revision 1.1
> done
> visage:/home/ian/r% cat x.c
> l1
> l2
> l3
> 
> With no RCS directory (ok):
> ---------------------------
> 
> visage:/home/ian/r% rm -f * RCS/*
> rm: RCS: is a directory
> visage:/home/ian/r% rmdir RCS
> visage:/home/ian/r% cat > x.c
> l1
> l2
> l3
> visage:/home/ian/r% ci x.c
> x.c,v  <--  x.c
> enter description, terminated with single '.' or end of file:
> NOTE: This is NOT the log message!
> >> .
> initial revision: 1.1
> done
> visage:/home/ian/r% ls -l
> total 1
> -r--r--r--   1 544      everyone      194 Mar  8 20:11 x.c,v
> visage:/home/ian/r% co x.c
> x.c,v  -->  x.c
> revision 1.1
> done
> visage:/home/ian/r% cat x.c
> l1
> l2
> l3
> --
>          Oooo.    | Ian Lowrey
>   .oooO  (   )    | [email-masked]
>   (   )   ) /     |
>    \ (   (_/      | "All dressed up with no place to go
>     \_)           |  On a music box that never stops..."
> -
> For help on using this list (especially unsubscribing), send a message to
> "[email-masked]" with one line of text: "help".

-- 
Erwin Achermann                               Tel:      ++41 1 632 74 40
Institut fuer Wissenschaftliches Rechnen      Fax:      ++41 1 632 11 72
ETH Zentrum, IFW C29.2         mailto:[email-masked]  ICQ:4625051
CH-8092 Zuerich	               http://www.inf.ethz.ch/personal/acherman/
>  Perfection is reached, not when there is no longer anything to add, <
>  but when there is no longer anything to take away.                  <
>                                          -- Antoine de Saint-Exupery <
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".